#include <stdio.h>
#include <stdlib.h>
#include <iostream>
using namespace std;

int main()
{
      float a = 3.45;
	  printf("original a: %f\n", a);
      cout << "original a: " << a << endl;

	  float* p;
	  float& b = a;   // reference (used like a variable, but really a "kind of" pointer)
	  b = 45.;
	  printf("changed a= %f, b= %f\n", a, b);
      cout << "changed a= " << a << ", b= " << b << endl;

	  // type of "a" is a float
	  // type of "b" is a reference to float
	  // type of "&b" is a pointer

	  if (typeid(&b) == typeid(a)) {
			 printf("types of &b and &a are identical\n");
             cout << "types of &b and &a are identical" << endl;
	  } else {
			 printf("types of &b and &a are NOT identical\n"); // TRUE
             cout << "types of &b and &a are NOT identical" << endl;
	  }

	  if (typeid(&b) == typeid(p)) {
			 printf("types of &b and p are identical\n");  // TRUE
             cout << "types of &b and p are identical" << endl;
	  } else {
			 printf("types of &b and p are NOT identical\n");
             cout << "types of &b and p are NOT identical" << endl;
	  }

	  float c = -14.;

	  printf("\n\n original c: %f\n", c);
      cout << "original c: " << c << endl;

	  b = c;    // reference is NOT changed. It is actually a that is changed.
	            // reference b still points to a (contrary to Java!!)

	  printf("a,b,c= %f, %f, %f\n", a, b, c);
      cout << "a,b,c= " << a << ", " << b << ", " << c << endl;

	  b = 17.;

	  printf("a,b,c= %f, %f, %f\n", a, b, c);
      cout << "a,b,c= " << a << ", " << b << ", " << c << endl;

	  printf("a is changed, c is unchanged\n");
      cout << "a is changed, c is unchanged" << endl;

	  printf("-----------------\n");
	  cout << "typeid(&b).name: " << typeid(&b).name() << endl;

	  printf("(address of b) &b = %p\n", &b);
      cout << "(address of b) &b = " << &b << endl;

	  printf("(address of a) &a = %lu\n", (unsigned long) &a);
      cout << "(address of a) &a = " << (unsigned long) &a << endl;

	  //printf("*b = %d\n", (int) *b);
	  //printf("&&b = %u\n", &&b); // INVALID

	  exit(0);
}



